      FUNCTION QFRMTP(T,P)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    QFRMTP      SPEC. HUM. FROM TEMP AND PRESSURE
C   PRGMMR: DIMEGO           ORG: W/NMC22    DATE: 88-03-31
C
C ABSTRACT: COMPUTE SPECIFIC HUMIDITY (SATURATED VALUE) AT THE
C   INDICATED TEMPERATURE AND PRESSURE
C
C PROGRAM HISTORY LOG:
C   75-03-31  DORIS GORDON
C   88-06-30  DIMEGO      DOCBLOCK HALF / FTN200
C
C USAGE:    WXYZ=QFRMTP(T,P)
C   INPUT ARGUMENT LIST:
C     T        - TEMPERATURE IN DEGREES KELVIN
C     P        - PRESSURE IN MB
C
C   OUTPUT ARGUMENT LIST:
C     QFRMTP   - FUNCTION VALUE RETURNED G/G
C
C ATTRIBUTES:
C   LANGUAGE: standard FORTRAN
C   MACHINE:  
C
C$$$
      IMPLICIT REAL (A-H,O-Z)
      A = T - 273.16
      ES = 6.1078 * EXP((17.269*A)/(A+237.3))
      QFRMTP = 0.622 * ES/(P - 0.378 * ES)
      RETURN
      END
